## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 57;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name: ctk
Version: 0.1
%global soname_version 0.1
Release: %autorelease
Summary: The Commmon Toolkit for biomedical imaging

# The entire source is Apache-2.0; CMake/CMakeFindDependencyMacro.cmake is
# BSD-3-Clause, but does not contribute to the licenses of the binary RPMs.
License: Apache-2.0
URL: https://commontk.org/
Source: https://github.com/commontk/CTK/archive/2018-10-29/CTK-2018-10-29.tar.gz

Patch: ctk-0.1.20171224git71799c2-fix_qreal_cast.patch
Patch: ctk-DCMTK_3.6.4_updated_function.patch

BuildRequires: gcc-c++

BuildRequires: cmake
BuildRequires: ninja-build

BuildRequires: cmake(dcmtk)
BuildRequires: qt-devel

Obsoletes: ctk-doc < 0.1-45

%global _description %{expand:
The Common Toolkit is a community effort to provide support code for medical
image analysis, surgical navigation, and related projects.}

%description %{_description}

This package contains the CTK Core library.


%package dicom

Summary: Library of high-level classes for querying PACS and local databases

Requires: ctk%{?_isa} = %{version}-%{release}
Requires: ctk-widgets%{?_isa} = %{version}-%{release}

%description dicom %{_description}

DICOM library provides high-level classes supporting query and retrieve
operations from PACS and local databases. It includes Qt widgets to easily
set-up a server connection and to send queries and view the results.


%package plugin-framework

Summary: A dynamic component system for C++

Requires: ctk%{?_isa} = %{version}-%{release}

%description plugin-framework %{_description}

The Plugin Framework is a dynamic component system for C++, modeled after the
OSGi specifications. It enable a development model where applications are
(dynamically) composed of many different (reusable) components following a
service oriented approach.


%package widgets

Summary: A collection of Qt widgets for biomedical imaging applications

Requires: ctk%{?_isa} = %{version}-%{release}

%description widgets %{_description}

The Widgets library is a collection of Qt widgets for usage in biomedical
imaging applications.


%package devel

Summary: Development files for the Common Toolkit

Requires: ctk%{?_isa} = %{version}-%{release}
Requires: ctk-dicom%{?_isa} = %{version}-%{release}
Requires: ctk-plugin-framework%{?_isa} = %{version}-%{release}
Requires: ctk-widgets%{?_isa} = %{version}-%{release}
Requires: dcmtk-devel%{?_isa}
Requires: qt-devel%{?_isa}

%description devel %{_description}

This package contains files for development of CTK applications.


%prep
%autosetup -n CTK-2018-10-29 -p1

%build
%cmake \
    -GNinja \
    -DCMAKE_PREFIX_PATH=%{_libdir}/cmake/InsightToolkit \
    -DCTK_SUPERBUILD=OFF \
    -DCTK_INSTALL_LIB_DIR=%{_libdir} \
    -DCTK_INSTALL_CMAKE_DIR=%{_libdir}/cmake/ctk \
    -DCTK_INSTALL_PLUGIN_DIR=%{_libdir}/ctk/plugins \
    -DCTK_INSTALL_QTPLUGIN_DIR=%{_qt4_plugindir} \
    -DCTK_ENABLE_DICOM=ON \
    -DCTK_ENABLE_PluginFramework=ON \
    -DCTK_ENABLE_Widgets=ON \
    -DDOCUMENTATION_TARGET_IN_ALL=OFF \
    -DBUILD_TESTING:BOOL=OFF
%cmake_build


%install
%cmake_install


# No %%check section here because running tests requires working X server
# and data files that are distributed without any copyright/license info
# (see https://github.com/commontk/CTKData/issues/1).


%files
%doc README.rst
%license NOTICE LICENSE
%{_libdir}/libCTKCore.so.%{soname_version}{,.*}

%files dicom
%{_libdir}/libCTKDICOMCore.so.%{soname_version}{,.*}
%{_libdir}/libCTKDICOMWidgets.so.%{soname_version}{,.*}

%files plugin-framework
%{_libdir}/libCTKPluginFramework.so.%{soname_version}{,.*}

%files widgets
%{_libdir}/libCTKWidgets.so.%{soname_version}{,.*}

%files devel
%{_includedir}/ctk-%{soname_version}/
%{_libdir}/libCTKCore.so
%{_libdir}/libCTKDICOMCore.so
%{_libdir}/libCTKDICOMWidgets.so
%{_libdir}/libCTKPluginFramework.so
%{_libdir}/libCTKWidgets.so
%{_qt4_plugindir}/designer/libCTKDICOMWidgetsPlugins.so
%{_qt4_plugindir}/designer/libCTKWidgetsPlugins.so
%{_libdir}/cmake/ctk/


%changelog
## START: Generated by rpmautospec
* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-57
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-56
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-55
- Convert License to SPDX

* Mon Jan 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-53
- Depend on dcmtk-devel from the -devel package

* Mon Jan 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-52
- Add missing fully-versioned inter-subpackage dependencies

* Mon Jan 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-51
- Write dcmtk-devel BuildRequires as cmake(dcmtk)

* Mon Jan 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-50
- Drop spurious or indirect BuildRequires

* Mon Jan 15 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-49
- Don’t depend on cmake from the -devel package

* Sun Jan 14 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-44
- Stop building (and Obsolete) the -doc subpackage

* Sun Jan 14 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.1-39
- Update URL to HTTPS

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.26.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.25.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Aug 04 2022 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.1-0.24.20190721
- Rebuild for dcmtk soname bump

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.23.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.22.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Aug 09 2021 Richard Shaw <hobbes1069@gmail.com> - 0.1-0.21.20190721
- Rebuild for soname bump in dcmtk.

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.20.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.19.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Fri Sep 04 2020 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.1-0.18.20190721
- Fix build using correct cmake macros
- Remove uneeded exclude

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.17.20190721
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.16.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.15.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Jul 24 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.14.20190721
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Jul 21 2019 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 0.1-0.13.20190721
- Rebuild for ITK

* Sat Mar 02 2019 Antonio Trande <sagitterATfedoraproject.org> - 0.1-0.12.20181029
- Release 2018 10 29

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.11.20171224git71799c2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Jul 12 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.10.20171224git71799c2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.9.20171224git71799c2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jan 03 2018 Björn Esser <besser82@fedoraproject.org> - 0.1-0.8.20171224git71799c2
- Remove BR: tcp_wrappers (#1518758)

* Wed Jan 03 2018 Björn Esser <besser82@fedoraproject.org> - 0.1-0.7.20171224git71799c2
- Update to recent snapshot

* Wed Jan 03 2018 Björn Esser <besser82@fedoraproject.org> - 0.1-0.6.20151015gitbdc8cac
- Rebuilt for dcmtk

* Sun Aug 06 2017 Björn Esser <besser82@fedoraproject.org> - 0.1-0.5.20151015gitbdc8cac
- Rebuilt for AutoReq cmake-filesystem

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.4.20151015gitbdc8cac
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.3.20151015gitbdc8cac
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.1-0.2.20151015gitbdc8cac
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Feb 2 2016 Dmitry Mikhirev <mikhirev@gmail.com> 0.1-0.1.20151015gitbdc8cac
- Initial package

## END: Generated by rpmautospec
